/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "private.h"

/*
 *
 * @param n the node
 * @param response true if this reply is in response to a network packet
 * 				   false if this reply is due to the node changing it's conditions
 *
 */
void send_poll_reply(node n, int response) {
	artnet_packet_t reply ;
	int i ;
	
	if( ! response && n->state.mode == ARTNET_ON) {
		n->state.ar_count++ ;
	}

	reply.to = n->state.reply_addr ;
	reply.type = ARTNET_REPLY ;
	reply.length = sizeof(artnet_reply_t) ;

	// copy from a poll reply template
	memcpy(&reply.data, &n->ar_temp , sizeof(artnet_reply_t)  ) ; 
 
	for (i=0; i< ARTNET_MAX_PORTS; i++) {
		reply.data.ar.goodinput[i] = n->ports.in[i].port_status ;
		reply.data.ar.goodoutput[i] = n->ports.out[i].port_status ;
	}

	snprintf((char *) &reply.data.ar.nodereport,sizeof(reply.data.ar.nodereport) , "%04hx [%04i] libartnet" , n->state.report_code , n->state.ar_count)  ;

	net_send(n, &reply) ; 
}


void send_dmx(node n) {


}


void send_input(node n, int response) {
	artnet_packet_t reply ;
	int i ;


}

void send_tod_data(node n) {
	artnet_packet_t tod ;

	printf("sending tod data\n") ;

	tod.to = n->state.bcast_addr ;
	tod.type = ARTNET_TODDATA ;
	tod.length = sizeof(artnet_toddata_t) ;

	memset(&tod.data,0x00, tod.length) ;
	
	// set up the data
	memcpy( &tod.data.toddata.id, ARTNET_STRING, ARTNET_STRING_SIZE) ;
	tod.data.toddata.opCode = ARTNET_TODDATA;
	tod.data.toddata.verH = 0;
	tod.data.toddata.ver = ARTNET_VERSION;

	net_send(n, &tod) ; 


}

